﻿using PR11.Models;
using ReactiveUI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace PR11.ViewModels
{
    public class CalculatorViewModel : ReactiveObject
    {
        public List<String> Operations  => AllOperations.all;
        int selectedOperation = 0;
        string a = "", b = "", result = "", message=" ";

        public int SelectedOperation
        {
            get => selectedOperation;
            set => this.RaiseAndSetIfChanged(ref selectedOperation, value, "");
        }

        public string A { get => a; set => this.RaiseAndSetIfChanged(ref a, value); }
        public string B { get => b; set => this.RaiseAndSetIfChanged(ref b, value); }
        public string Result { get => result; set => this.RaiseAndSetIfChanged(ref result, value); }
        public string Message { get => message; set => this.RaiseAndSetIfChanged(ref message, value); }
        public string Operation
        {
            get
            {
                switch (SelectedOperation)
                {
                    case 0: return "+";
                        case 1: return "-";
                        case 2: return "*";
                        case 3: return "/";
                    default: return "Неопознанная ошибка";
                }
            }
        }

        public void Calculate()
        {
            Regex isItNumber = new Regex(@"^[0-9]*(\,[0-9]*)?$");
            if (isItNumber.IsMatch(A) && isItNumber.IsMatch(B))
            {
                double an, bn;
                an = Converter(A);
                bn = Converter(B);

                switch (SelectedOperation)
                {
                    case 0: Result = Convert.ToString(an + bn); break;
                    case 1: Result = Convert.ToString(an - bn); break;
                    case 2: Result = Convert.ToString(an * bn); break;
                    case 3:{ 
                            if (bn == 0)
                            {
                                Result = "На 0 делить нельзя!"; break;
                            }
                            else
                            {
                                Result = Convert.ToString(an / bn); break;
                            }
                        } 
                    default: Result = "Неопознанная ошибка"; break;
                }
            }
            else
            {
                Message = "Некорректные данные. Пример верного ввода: -123,03";
            }
        }

        double Converter(string n)
        {
            double num;
            if (n[0] == '-')
            {
                num = Convert.ToDouble(n.Substring(1));
                num = 0 - num;
            }
            else
            {
                num = Convert.ToDouble(n);
            }
            return num;
        }
    }
}
