﻿using Avalonia;
using Avalonia.Controls;
using Avalonia.Controls.Shapes;
using Avalonia.Media;
using PR11.Views;
using ReactiveUI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PR11.ViewModels
{
    public class CaptchaViewModel : ReactiveObject
    {
        public CaptchaViewModel()
        {
            CreateCaptcha();
        }

        string inputting_data = "", check ="";
        Canvas captcha;
        public string InputtingData { get => inputting_data; set => this.RaiseAndSetIfChanged(ref inputting_data, value); }
        public string CorrectData { get => check; set => this.RaiseAndSetIfChanged(ref check, value); }
        public Canvas Captcha
        {
            get => captcha;
            set => this.RaiseAndSetIfChanged(ref captcha, value);
        }

        public void CreateCaptcha()
        {
            SolidColorBrush color = new SolidColorBrush(Color.FromRgb(252, 222, 179));
            Canvas canvas = new Canvas()
            {
                Width = 210,
                Height = 100,
                Background = color
            };
            Random rnd = new Random();
            TextBlock text = new TextBlock()
            {
                Text = Convert.ToString(rnd.Next(0, 9)),
                FontSize = 36,
                Foreground = Brushes.Black,
                Padding = new Thickness(20)
            };
            TextBlock text1 = new TextBlock()
            {
                Text = Convert.ToString(Convert.ToChar(rnd.Next(97, 123))),
                FontSize = 36,
                Foreground = Brushes.Black,
                Padding = new Thickness(40)
            };
            TextBlock text2 = new TextBlock()
            {
                Text = Convert.ToString(rnd.Next(0, 20)),
                FontSize = 36,
                Foreground = Brushes.Black,
                Padding = new Thickness(60, 10),
            };
            TextBlock text3 = new TextBlock()
            {
                Text = Convert.ToString(Convert.ToChar(rnd.Next(97, 123))),
                FontSize = 36,
                Foreground = Brushes.Black,
                Padding = new Thickness(100, 2)
            };
            TextBlock text4 = new TextBlock()
            {
                Text = Convert.ToString(rnd.Next(0, 9)),
                FontSize = 36,
                Foreground = Brushes.Black,
                Padding = new Thickness(130, 10)
            };
            TextBlock text5 = new TextBlock()
            {
                Text = Convert.ToString(Convert.ToChar(rnd.Next(65, 91))),
                FontSize = 36,
                Foreground = Brushes.Black,
                Padding = new Thickness(150, 1)
            };
            TextBlock text6 = new TextBlock()
            {
                Text = Convert.ToString(Convert.ToChar(rnd.Next(97, 123))),
                FontSize = 36,
                Foreground = Brushes.Black,
                Padding = new Thickness(170, -3)
            };
            canvas.Children.Add(text);
            canvas.Children.Add(text1);
            canvas.Children.Add(text2);
            canvas.Children.Add(text3);
            canvas.Children.Add(text4);
            canvas.Children.Add(text5);
            canvas.Children.Add(text6);
            CorrectData = text.Text + text1.Text + text2.Text + text3.Text + text4.Text + text5.Text + text6.Text;
            for (int i = 0; i <= 10; i++)
            {
                Line line = new Line()
                {
                    StartPoint = new Point(rnd.Next(220), rnd.Next(100)),
                    EndPoint = new Point(rnd.Next(220), rnd.Next(100)),
                    Stroke = new SolidColorBrush(Color.FromRgb(Convert.ToByte(rnd.Next(0, 155)), Convert.ToByte(rnd.Next(0, 155)), Convert.ToByte(rnd.Next(0, 155)))),
                    StrokeThickness = 2
                };
                canvas.Children.Add(line);
            }
            Captcha = canvas;
        }
    }
}