﻿using Avalonia.Controls;
using Avalonia.Threading;
using PR11.Views;
using ReactiveUI;
using System;
using Tmds.DBus.Protocol;

namespace PR11.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {

        public UserControl us = new Authorization();

        public UserControl US
        {
            get => us;
            set => this.RaiseAndSetIfChanged(ref us, value);
        }

        public UserControl catchaAu = null;

        public UserControl CaptchaAu
        {
            get => catchaAu;
            set => this.RaiseAndSetIfChanged(ref catchaAu, value);
        }

        public AuthorizationViewModel PageAutorization { get => pageAutorization; set => pageAutorization = value; }
        public CalculatorViewModel PageCalculator { get => pageCalculator; set => pageCalculator = value; }
        public CaptchaViewModel PageCaptcha { get => pageCaptcha; set => pageCaptcha = value; }
        AuthorizationViewModel pageAutorization = new AuthorizationViewModel();
        CalculatorViewModel pageCalculator = new CalculatorViewModel();
        CaptchaViewModel pageCaptcha = new CaptchaViewModel();

        int count_trying = 0;
        bool visibility = true;

        DispatcherTimer timer = new DispatcherTimer();

        public bool VisibilityButton
        {
            get => visibility;
            set => this.RaiseAndSetIfChanged(ref visibility, value);
        }

        public void Auto_Click()
        {
            if (CheckingData() && (pageAutorization.Login == Models.AuthorizationDataClass.login) && (pageAutorization.Password == Models.AuthorizationDataClass.password))
            {
                US = new Calculator();
            }
            else
            {
                pageAutorization.Message = "Неверные данные для выхода. Введите капчу и повторите попытку.";
                pageAutorization.Login = "";
                pageAutorization.Password = "";
                PageCaptcha.InputtingData = "";
                if (count_trying == 0)
                {
                    count_trying++;
                    CaptchaAu = new Captcha();
                }
                else
                {
                    CaptchaAu = null;
                    VisibilityButton = false;
                    pageAutorization.Message = "Неверные данные. Подождите 10 секунд и повторите попытку.";
                    timer.Interval = new TimeSpan(0, 0, 10);
                    timer.Tick += stopTimer;
                    timer.Start();
                }
            }
        }

        public bool CheckingData()
        {
            if ((PageCaptcha.CorrectData == PageCaptcha.InputtingData)||CaptchaAu==null) { CaptchaAu = null; return true; }
            return false;
        }

        private void stopTimer(object sender, EventArgs e)
        {
            VisibilityButton = true;
            pageAutorization.Message = "Повторите попытку.";
            PageCaptcha.CreateCaptcha(); //почему-то без вызова метода вне конструктора генерация именно новой капчи не работает
            CaptchaAu = new Captcha();
            timer.Stop();
        }
    }
}